/* koemp3.c
   SCMPXpāAkoeunpacō쐬koewavt@CWAV
   MP3-WAVE`ɕϊ

   01/04/21 initial
   04/01/11 ֌WȂtH_ŎsƂG[bZ[WoȂ
*/
#include <stdio.h>
#include <io.h>
#include <windows.h>

#define PROGNAME	"koemp3.exe"
#define INMMREGKEY	"Software\\irori\\_inmm.dll"

char scmpx_path[MAX_PATH] = "scmpx.exe";

int msgboxf(UINT style, const char* fmt, va_list arglist)
{
	char buf[1024];
	vsprintf(buf, fmt, arglist);
	return MessageBox(NULL, buf, PROGNAME, style);
}

void showerror(const char* fmt, ...)
{
	va_list argptr;

	va_start(argptr, fmt);
	msgboxf(MB_OK | MB_ICONSTOP, fmt, argptr);
	va_end(argptr);
}

int abort_retry_ignore(const char* fmt, ...)
{
	int r;
	va_list argptr;

	va_start(argptr, fmt);
	r = msgboxf(MB_ABORTRETRYIGNORE | MB_ICONSTOP, fmt, argptr);
	va_end(argptr);
	return r;
}

int init_scmpx_path(void)
{
	HKEY hkey;
	LONG r;
	DWORD size = sizeof scmpx_path;

	r = RegOpenKeyEx(HKEY_CURRENT_USER, INMMREGKEY, 0, KEY_QUERY_VALUE, &hkey);
	if (r != ERROR_SUCCESS) {
		fprintf(stderr, "_inmm.dll̃WXg܂B\n");
		return 0;
	}

	r = RegQueryValueEx(hkey, "SMX_Path", 0, NULL, scmpx_path, &size);
	RegCloseKey(hkey);
	if (r != ERROR_SUCCESS) {
		fprintf(stderr, "WXg̓ǂ݂ƂɎs܂BB\n");
		return 0;
	}

	if (size <= 1)		/* SCMPX̃pXݒ */
		strcpy(scmpx_path, "scmpx.exe");
	
	return 1;
}

void dofile(const char* filename)
{
	char mp3name[MAX_PATH];
	char cmd[1000];
	
	sprintf(mp3name, "%s.mp3", filename);
	sprintf(cmd, "%s -e -w %s %s", scmpx_path, filename, mp3name);
	printf("%s\n", cmd);

	/* SCMPXNĕϊ */
	while (system(cmd) != 0) {
		switch (abort_retry_ignore(
			"%s: scmpxNłȂAϊɎs܂B", filename)) {
		case IDABORT:	exit(1);
		case IDIGNORE:	return;
		}
	}
	/* wavt@C폜 */
	while (remove(filename) == -1) {
		switch (abort_retry_ignore("%s̍폜Ɏs܂: %s",
								   filename, strerror(errno))) {
		case IDABORT:	exit(1);
		case IDIGNORE:	return;
		}
	}
	/* ϊꂽRIFF-WAVEt@C̖OɃl[ */
	while (rename(mp3name, filename) == -1) {
		switch (abort_retry_ignore("%s%sɃl[ł܂: %s",
								   mp3name, filename, strerror(errno))) {
		case IDABORT:	exit(1);
		case IDIGNORE:	return;
		}
	}
}

int dodir(const char* dirname)
{
	long hf;
	struct _finddata_t fd;
	char pat[MAX_PATH], fname[MAX_PATH];

	sprintf(pat, "%s\\*.wav", dirname);
	
	hf = _findfirst(pat, &fd);
	if (hf == -1) {
		fprintf(stderr, "%s: wavt@C܂B\n", dirname);
		return 0;
	}
	else {
		do {
			sprintf(fname, "%s\\%s", dirname, fd.name);
			dofile(fname);
		} while (_findnext(hf, &fd) == 0);
		_findclose(hf);
		return 1;
	}
}

int main(void)
{
	long hf;
	struct _finddata_t fd;
	int done = 0;
	
	init_scmpx_path();

	hf = _findfirst("???", &fd);
	if (hf != -1) {
		do {
			if (fd.name[0] != '.' && fd.attrib & _A_SUBDIR)
				done |= dodir(fd.name);
		} while (_findnext(hf, &fd) == 0);
		_findclose(hf);
	}
	if (!done)
		showerror("koeunpacō쐬ꂽkoewavtH_ŎsĂB");
	return (done ? 0 : 1);
}
